CreateMDIControls     PROTO   :DWORD

.const
NoMDITbFileButtons   equ     5
NoMDIToolbarBitmaps  equ     4

MDITbFileId     equ     5000h
MDIReBarId      equ     5001h
IDB_OPEN	    equ     600h
IDB_SAVE        equ     601h
IDB_SAVEAS      equ     602h
IDB_CLOSE       equ     603h

WS_COMMON       equ     WS_VISIBLE+WS_CHILD

MDIStruct   STRUCT
hReBar      HWND        ?
hTbFile     HWND        ?
hIml        dd          ?
MDIStruct   ENDS

.data
lpDefToolbarProc        LPSTR       ?

MDITbFileButtons        TBBUTTON    <0,IDB_OPEN,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                        TBBUTTON    <1,IDB_SAVE,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                        TBBUTTON    <2,IDB_SAVEAS,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                        TBBUTTON    <0,0,0,BTNS_SEP,0,0>
                        TBBUTTON    <3,IDB_CLOSE,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
MDIToolbarBmpIds dd          103,104,105,106,129,130,125,126                

.code

MDIChildProc    PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if     uMsg==WM_CREATE
            
            invoke  LocalAlloc,16,LPTR
            mov     edi,eax
            invoke  SetWindowLong,hWnd,0,edi
            invoke  CreateMDIControls,hWnd
            
    .elseif uMsg==WM_SYSCOMMAND
        .if     wParam==SC_CLOSE
close_window:         
            invoke  GetWindowLong,hWnd,0
            invoke  LocalFree,eax
            invoke  SendMessage,hMDIClient,WM_MDIDESTROY,hWnd,0

    .elseif uMsg==WM_COMMAND
            mov     eax,wParam
            .if     ax==IDB_CLOSE
                invoke  Beep,200,20
                jmp     close_window
            .endif            
    .else
            jmp     default_processing            
    .endif                                       
.else
default_processing:
        invoke  DefMDIChildProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor     eax,eax
    ret
            
MDIChildProc    endp

CreateMDIControls   PROC    hWnd:DWORD

    invoke  GetWindowLong,hWnd,0
    mov     edi,eax
    assume  edi:PTR MDIStruct
    invoke  CreateWindowEx,0,addr ReBarClass,0,WS_VISIBLE+WS_CHILD+RBS_AUTOSIZE+CCS_NODIVIDER,\
                CWUD,CWUD,CWUD,CWUD,hWnd,MDIReBarId,hInstance,0
    mov     [edi].hReBar,eax                                        
    invoke  CreateWindowEx,0,addr ToolbarClass,0,WS_COMMON+TBSTYLE_FLAT+CCS_NODIVIDER+CCS_NOPARENTALIGN,\
                CWUD,CWUD,CWUD,CWUD,[edi].hReBar,TbFileId,hInstance,0
    mov     [edi].hTbFile,eax
    invoke  SendMessage,hTbFile,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
    call    CreateMDIImageList
    invoke  SendMessage,[edi].hTbFile,TB_SETIMAGELIST,0,[edi].hIml
    invoke  SendMessage,[edi].hTbFile,TB_ADDBUTTONS,NoMDITbFileButtons,addr MDITbFileButtons
    push    [edi].hTbFile
    pop     rbbi.hwndChild
    invoke  SendMessage,[edi].hReBar,RB_INSERTBAND,-1,addr rbbi
    ret

CreateMDIControls   endp

CreateMDIImageList  PROC

    local   hBmp:DWORD
    local   hBmpMask:DWORD
    
    invoke  ImageList_Create,30,30,ILC_COLOR32+ILC_MASK,NoMDIToolbarBitmaps,\
                NoMDIToolbarBitmaps+10
    mov     [edi].hIml,eax
    lea     esi,MDIToolbarBmpIds
    mov     ecx,NoMDIToolbarBitmaps
    cld
loop_1:                 
    lodsd
    push    ecx
    invoke  LoadImage,hInstance,eax,IMAGE_BITMAP,30,30,0
    mov     hBmp,eax
    lodsd
    invoke  LoadImage,hInstance,eax,IMAGE_BITMAP,30,30,0
    mov     hBmpMask,eax
    invoke  ImageList_Add,[edi].hIml,hBmp,eax
    invoke  DeleteObject,hBmp
    invoke  DeleteObject,hBmpMask
    pop     ecx
    dec     ecx
    jcxz    end_loop_1
    jmp     loop_1
end_loop_1:    
    ret

CreateMDIImageList  endp       

