__UNICODE__ equ 1
.586
.model flat,stdcall
option  casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
CreateMenus     PROTO   :DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib
include \masm32\macros\macros.asm
.const  
MainWindowWidth     equ     600
MainWindowHeight    equ     400


.data
hInstance       HINSTANCE       ?
hMainWindow     HWND            ?
UCSTR           MainWindowClass, "MainWindowClass",0
UCSTR           MainWindowName,  "The Drawing Gismo",0
wcex            WNDCLASSEX      <sizeof wcex,CS_HREDRAW+CS_VREDRAW,offset WndProc,\
                                0,0,?,?,?,COLOR_WINDOW,0,offset MainWindowClass,?>
rect            RECT            <>

; ++++ MDI Related ++++

UCSTR           MDIChildClass,"MDIChildClass",0
wcMDI           WNDCLASSEX      <sizeof wcMDI,CS_HREDRAW+CS_VREDRAW,offset MDIChildProc,\
                                4,4,?,?,?,COLOR_WINDOW,0,offset MDIChildClass,?>
mdics           MDICREATESTRUCT <>

; ++++ Common Controls related ++++
                                
iccx            INITCOMMONCONTROLSEX    <sizeof iccx,ICC_COOL_CLASSES+ICC_BAR_CLASSES>                                

; ++++ Other Vars ++++

CurrentUnnamedImage     dd      1
UCSTR                   szUnnamed,"Unnamed Image ",0       
NumBuffer               db      16 dup(0),'H',0,0,0,0,0
hDeferWnd               dd      ?


include .\tdg.inc
include .\menu_and_controls.asm
;include .\Drawing_Board.asm
include .\MDIProc.asm
include .\misc.asm
                  
.code
    start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  WinMain,hInstance,0,0,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInst
    pop     wcex.hInstance
    invoke  LoadIcon,hInstance,100
    mov     wcex.hIcon,eax
    mov     wcex.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wcex.hCursor,eax
    invoke  RegisterClassEx,addr wcex
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,WS_EX_APPWINDOW ,addr MainWindowClass,addr MainWindowName,\
                WS_OVERLAPPEDWINDOW+WS_CLIPCHILDREN,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,SW_SHOWNORMAL
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop                        
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC   uses esi edi hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if     uMsg==WM_CREATE
        mov     edi,lParam
        .if     [edi.CREATESTRUCT].hWndParent==0
            invoke  InitCommonControlsEx,addr iccx
            invoke  CreateMenus,hWnd
            invoke  CreateControls,hWnd
        .else
            invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
            ret
        .endif            
    .elseif uMsg==WM_COMMAND
        mov     eax,wParam
        .if     ax==IDM_NEW
            invoke  LoadIcon,hInstance,100
            mov     wcMDI.hIcon,eax
            mov     wcMDI.hIconSm,eax
            invoke  LoadCursor,0,IDC_ARROW
            mov     wcMDI.hCursor,eax
            invoke  RegisterClassEx,addr wcMDI
            invoke  GetClientRect,hWnd,addr rect
            invoke  SendMessage,hReBar,RB_GETBARHEIGHT,0,0
            sub     rect.bottom,eax
            invoke  ConvertToHex,CurrentUnnamedImage
            invoke  UnicodeAdd,addr NumBuffer,addr szUnnamed
            invoke  CreateWindowEx,WS_EX_MDICHILD,addr MDIChildClass,addr szUnnamed,MDIS_ALLCHILDSTYLES,\
                       rect.left,rect.top,rect.right,rect.bottom,hMDIClient,0,hInstance,addr mdics
            inc     CurrentUnnamedImage
            invoke  UnicodeDel,addr szUnnamed  
        .elseif ax==IDB_CLOSE
            invoke  Beep,200,20
            invoke  SendMessage,hMDIClient,WM_MDIGETACTIVE,0,0
            push    eax
            invoke  GetWindowLong,eax,0
            invoke  LocalFree,eax
            pop     eax
            invoke  SendMessage,hMDIClient,WM_MDIDESTROY,eax,0
        .endif     
                  
    .elseif uMsg==WM_SIZE
            invoke  SendMessage,hReBar,RB_GETRECT,0,addr rect
            mov     eax,rect.right
            sub     eax,rect.left
            push    eax
            invoke  SendMessage,hReBar,RB_GETRECT,1,addr rect
            mov     eax,rect.right
            sub     eax,rect.left
            pop     ebx
            add     ebx,eax
            movzx   eax,word ptr lParam
            cmp     eax,ebx
            ja      no_size2rect
            invoke  BeginDeferWindowPos,1
            mov     hDeferWnd,eax
            invoke  SendMessage,hReBar,RB_GETBARHEIGHT,0,0
            shr     eax,1
            movzx   ebx,word ptr lParam
            invoke  DeferWindowPos,hDeferWnd,hReBar,0,0,0,ebx,eax,SWP_NOMOVE\
                        +SWP_NOOWNERZORDER+SWP_NOZORDER+SWP_DRAWFRAME
 ;           invoke  MoveWindow,hReBar,0,0,ebx,eax,FALSE;TRUE
            invoke  EndDeferWindowPos,hDeferWnd
            jmp     skip_sizetorect
no_size2rect:
            invoke  SendMessage,hReBar,RB_GETBARHEIGHT,0,0
            movzx   ebx,word ptr lParam
            invoke  MoveWindow,hReBar,0,0,ebx,eax,FALSE;TRUE
skip_sizetorect:            
            invoke  GetClientRect,hWnd,addr rect
            invoke  SendMessage,hReBar,RB_GETBARHEIGHT,0,0
            mov     rect.top,eax
            sub     rect.bottom,eax
            movzx   eax,word ptr lParam
            invoke  MoveWindow,hMDIClient,rect.left,rect.top,eax,rect.bottom,FALSE;TRUE
skip_wms:        
    .elseif uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .else
DefaultProcessing:    
        invoke  DefFrameProc,hWnd,hMDIClient,uMsg,wParam,lParam
        ret
    .endif
    xor     eax,eax
    ret

WndProc     endp                                                

end     start